/* 
 *  Copyright 2005 The Apache Software Foundation or its licensors, as applicable.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

#include "DivideServiceImpl_DivideService_Wrapper.h"

#include "osoa/sca/sca.h"
using namespace osoa::sca;
using namespace tuscany::sca;



extern "C"
{

    #if defined(WIN32) || defined(_WINDOWS)
    __declspec(dllexport) 
    #endif
    DivideServiceImpl_DivideService_Wrapper* DivideServiceImpl_DivideService_Wrapper_Factory(tuscany::sca::model::Service* target)
    {
        return new DivideServiceImpl_DivideService_Wrapper(target);
    }
}

DivideServiceImpl_DivideService_Wrapper::DivideServiceImpl_DivideService_Wrapper(Service* target) : ComponentServiceWrapper(target)
{
    impl = (DivideServiceImpl*)getImplementation();
}

DivideServiceImpl_DivideService_Wrapper::~DivideServiceImpl_DivideService_Wrapper()
{
    releaseImplementation();
}

void* DivideServiceImpl_DivideService_Wrapper::newImplementation()
{
    return new DivideServiceImpl;
}

void DivideServiceImpl_DivideService_Wrapper::deleteImplementation()
{
    delete impl;
}

void DivideServiceImpl_DivideService_Wrapper::invokeService(Operation& operation)
{
    const string& operationName = operation.getName();

    if (operationName == "divide")
    {
        float& p0 = *( float*)operation.getParameterValue(0);
        float& p1 = *( float*)operation.getParameterValue(1);
        *(float*)operation.getReturnValue() = impl->divide(p0, p1);
        return;
    }
        

    throw ServiceRuntimeException("Invalid operation");
    
}

